
<?php
    // inclusion de la interface para obtener los metodos requeridos y de database.php para la interacción con base de datos
    require_once("database/Database.php");
    require_once("interface/interface.php");

// --------------------- DAHBOARD GENERAL --------------------- //

    class general extends Database implements iGeneral{

        // Obtiene la información general de todos los tickets 
        public function general_all_tickets($fechaini, $fechafin, $tipo){
            $sql = "SELECT ost1.number, ost4.topic, ost2.subject, ost5.name, ost5.area, ost5.depto,
            ost6.name AS regional, 
            ost7.nombre AS sucursal,
            DATE_FORMAT(ost1.created, '%d-%m-%Y') AS created, 
            DATE_FORMAT(ost1.lastupdate, '%d-%m-%Y') AS lastupdate, 
            DATE_FORMAT(ost1.closed, '%d-%m-%Y') AS closed, ost3.username, ost8.name AS departamento, 
            TIMEDIFF(ost11.timestamp, ost1.created) AS tiempoRespuesta, 
            TIMEDIFF(ost1.lastupdate, ost1.created) AS tiempo 
            FROM ost_ticket__cdata ost2 
            INNER JOIN ost_ticket ost1 ON ost2.ticket_id=ost1.ticket_id 
            INNER JOIN ost_staff ost3 ON ost3.staff_id=ost1.staff_id 
            INNER JOIN ost_help_topic ost4 ON ost1.topic_id=ost4.topic_id 
            INNER JOIN ost_user ost5 ON ost1.user_id = ost5.id 
            INNER JOIN ost_organization ost6 ON ost6.id = ost5.org_id
            INNER JOIN rot_sucursal ost7 ON ost5.id_sucursal COLLATE utf8_unicode_ci = ost7.id_sucursal COLLATE utf8_unicode_ci 
            INNER JOIN ost_department ost8 ON ost3.dept_id = ost8.id
            INNER JOIN (
                SELECT @row_number:= CASE
                    WHEN @object_id = object_id 
            			THEN @row_number + 1
                    ELSE 1 END 
            	AS rn,  @object_id := ost9.object_id as object_id, ost9.id, ost10.thread_id, ost10.event_id, MAX(ost10.timestamp) AS timestamp
                FROM ost_thread_event ost10 INNER JOIN ost_thread ost9 ON ost9.id = ost10.thread_id AND ost10.event_id = 4
                GROUP BY ost9.object_id
                ORDER BY ost9.object_id, ost10.timestamp DESC
                ) ost11 ON ost1.ticket_id = ost11.object_id AND ost11.rn = 1 ";
            if($fechaini != $fechafin){
                
                $fechaini = $fechaini.' 00:00:00';
                $fechafin = $fechafin.' 23:59:59';

                if($tipo == "All"){
                    $sql .= "WHERE ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                    OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."'
                    OR ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."' ";
                }
                elseif($tipo == "Open"){
                     $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                    OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."') AND ost1.closed IS NULL" ;
                }
                elseif($tipo == "Created"){
                    $sql .= "WHERE ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."' ";
                }
                elseif($tipo == "Updated"){
                    $sql .= "WHERE ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."' ";
                }
                elseif($tipo == "Closed"){
                    $sql .= "WHERE ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."' ";
                }
            }
            else{
                if($tipo == "All"){
                    $sql .="WHERE ost1.created like '".$fechaini."%'
                    OR ost1.lastupdate like '".$fechaini."%'
                    OR ost1.closed like '".$fechaini."%' ";
                }
                elseif($tipo == "Open"){
                    $sql .= "WHERE (ost1.created like '".$fechaini."%' OR ost1.lastupdate like '".$fechaini."%') AND ost1.closed IS NULL";
                }
                elseif($tipo == "Created"){
                    $sql .= "WHERE ost1.created like '".$fechaini."%' ";
                }
                elseif($tipo == "Updated"){
                    $sql .= "WHERE ost1.lastupdate like '".$fechaini."%' ";
                }
                elseif($tipo == "Closed"){
                    $sql .= "WHERE ost1.closed like '".$fechaini."%' ";
                }
            }
            $sql .= " ORDER BY ost1.ticket_id;";
            //echo $sql;
            return $this->getRows($sql);
        }

        //Obtiene la cantidad de tickets abiertos, cerrados y el total 
        public function general_cuantos_tickets($fechaini, $fechafin, $tipo){
            $sql = "SELECT SUM(uni.abiertos) AS abiertos, SUM(uni.cerrados) AS cerrados, (SUM(uni.abiertos) + SUM(uni.cerrados) ) AS cuantos FROM(
            SELECT count(*) AS abiertos, 0 AS cerrados 
            FROM ost_ticket__cdata ost2 
            INNER JOIN ost_ticket ost1 ON ost2.ticket_id=ost1.ticket_id 
            INNER JOIN ost_staff ost3 ON ost3.staff_id=ost1.staff_id 
            INNER JOIN ost_help_topic ost4 ON ost1.topic_id=ost4.topic_id 
            INNER JOIN ost_user ost5 ON ost1.user_id = ost5.id 
            INNER JOIN ost_organization ost6 ON ost6.id = ost5.org_id
            INNER JOIN rot_sucursal ost7 ON ost5.id_sucursal COLLATE utf8_unicode_ci = ost7.id_sucursal COLLATE utf8_unicode_ci 
            INNER JOIN ost_department ost8 ON ost3.dept_id = ost8.id
            INNER JOIN (
                 SELECT @row_number:= CASE
                    WHEN @object_id = object_id 
            			THEN @row_number + 1
                    ELSE 1 END 
            	AS rn,  @object_id := ost9.object_id as object_id, ost9.id, ost10.thread_id, ost10.event_id, MAX(ost10.timestamp) AS timestamp
                FROM ost_thread_event ost10 INNER JOIN ost_thread ost9 ON ost9.id = ost10.thread_id AND ost10.event_id = 4
                GROUP BY ost9.object_id
                ORDER BY ost9.object_id, ost10.timestamp DESC)
                ost11 ON ost1.ticket_id = ost11.object_id AND ost11.rn = 1 ";
            if($fechaini != $fechafin){

                $fechaini = $fechaini.' 00:00:00';
                $fechafin = $fechafin.' 23:59:59';

                if($tipo == "All"){
                    $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                    OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."'
                    OR ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."') ";
                }
                elseif($tipo == "Open"){
                     $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                    OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."') AND ost1.closed IS NULL" ;
                }
                elseif($tipo == "Created"){
                    $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."')";
                }
                elseif($tipo == "Updated"){
                    $sql .= "WHERE (ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."') ";
                }
                elseif($tipo == "Closed"){
                    $sql .= "WHERE (ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."') ";
                }
            }
            else{
                if($tipo == "All"){
                    $sql .="WHERE (ost1.created like '".$fechaini."%'
                    OR ost1.lastupdate like '".$fechaini."%'
                    OR ost1.closed like '".$fechaini."%') ";
                }
                elseif($tipo == "Open"){
                    $sql .= "WHERE (ost1.created like '".$fechaini."%' OR ost1.lastupdate like '".$fechaini."%') AND ost1.closed IS NULL ";
                }
                elseif($tipo == "Created"){
                    $sql .="WHERE (ost1.created like '".$fechaini."%') ";
                }
                elseif($tipo == "Updated"){
                    $sql .="WHERE (ost1.lastupdate like '".$fechaini."%') ";
                }
                elseif($tipo == "Closed"){
                    $sql .="WHERE (ost1.closed like '".$fechaini."%') ";
                }
            }
            $sql .= " AND ost1.closed IS NULL 
            UNION ALL
            SELECT 0 AS abiertos, count(*) AS cerrados
            FROM ost_ticket__cdata ost2 
            INNER JOIN ost_ticket ost1 ON ost2.ticket_id=ost1.ticket_id 
            INNER JOIN ost_staff ost3 ON ost3.staff_id=ost1.staff_id 
            INNER JOIN ost_help_topic ost4 ON ost1.topic_id=ost4.topic_id 
            INNER JOIN ost_user ost5 ON ost1.user_id = ost5.id 
            INNER JOIN ost_organization ost6 ON ost6.id = ost5.org_id
            INNER JOIN rot_sucursal ost7 ON ost5.id_sucursal COLLATE utf8_unicode_ci = ost7.id_sucursal COLLATE utf8_unicode_ci 
            INNER JOIN ost_department ost8 ON ost3.dept_id = ost8.id
            INNER JOIN (
                SELECT @row_number:= CASE
                    WHEN @object_id = object_id 
            			THEN @row_number + 1
                    ELSE 1 END 
            	AS rn,  @object_id := ost9.object_id as object_id, ost9.id, ost10.thread_id, ost10.event_id, MAX(ost10.timestamp) AS timestamp
                FROM ost_thread_event ost10 INNER JOIN ost_thread ost9 ON ost9.id = ost10.thread_id AND ost10.event_id = 4
                GROUP BY ost9.object_id
                ORDER BY ost9.object_id, ost10.timestamp DESC)
                ost11 ON ost1.ticket_id = ost11.object_id AND ost11.rn = 1 ";
            if($fechaini != $fechafin){

                $fechaini = $fechaini.' 00:00:00';
                $fechafin = $fechafin.' 23:59:59';

                if($tipo == "All"){
                    $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                    OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."'
                    OR ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."') ";
                }
                elseif($tipo == "Open"){
                     $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                    OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."') AND ost1.closed IS NULL" ;
                }
                elseif($tipo == "Created"){
                    $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."')";
                }
                elseif($tipo == "Updated"){
                    $sql .= "WHERE (ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."') ";
                }
                elseif($tipo == "Closed"){
                    $sql .= "WHERE (ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."') ";
                }
            }
            else{
                if($tipo == "All"){
                    $sql .="WHERE (ost1.created like '".$fechaini."%'
                    OR ost1.lastupdate like '".$fechaini."%'
                    OR ost1.closed like '".$fechaini."%') ";
                }
                elseif($tipo == "Open"){
                    $sql .= "WHERE (ost1.created like '".$fechaini."%' OR ost1.lastupdate like '".$fechaini."%') AND ost1.closed IS NULL ";
                }
                elseif($tipo == "Created"){
                    $sql .="WHERE (ost1.created like '".$fechaini."%') ";
                }
                elseif($tipo == "Updated"){
                    $sql .="WHERE (ost1.lastupdate like '".$fechaini."%') ";
                }
                elseif($tipo == "Closed"){
                    $sql .="WHERE (ost1.closed like '".$fechaini."%') ";
                }
            }
            $sql .= " AND ost1.closed IS NOT NULL 
             ) AS uni;";
            return $this->getRow($sql);
        }
    }

    // Objetos para usar en index.php
    $general = new general();
    $general2 = new general();

// --------------------- DAHBOARD GENERAL --------------------- //

// --------------------- DAHBOARD CATEGORIA --------------------- //

    class categoria extends Database implements iCategoria{

        //Obtiene todas las categorías del sistema 
        public function categoria_categoria(){
            $sql = "SELECT * FROM ost_help_topic WHERE topic_pid <> 87 ORDER BY updated";
            return $this->getRows($sql);
        }
        // Obtiene la información general de todos los tickets 
        public function categoria_all_tickets($fechaini, $fechafin, $tipo, $cate){
            $sql = "SELECT ost1.number, ost4.topic, ost2.subject, ost5.name, ost5.area, ost5.depto,
            ost6.name AS regional, 
            ost7.nombre AS sucursal,
            DATE_FORMAT(ost1.created, '%d-%m-%Y') AS created, 
            DATE_FORMAT(ost1.lastupdate, '%d-%m-%Y') AS lastupdate, 
            DATE_FORMAT(ost1.closed, '%d-%m-%Y') AS closed, ost3.username, ost8.name AS departamento, 
            TIMEDIFF(ost11.timestamp, ost1.created) AS tiempoRespuesta,
            TIMEDIFF(ost1.lastupdate, ost1.created) AS tiempo
            FROM ost_ticket__cdata ost2 
            INNER JOIN ost_ticket ost1 ON ost2.ticket_id=ost1.ticket_id 
            INNER JOIN ost_staff ost3 ON ost3.staff_id=ost1.staff_id 
            INNER JOIN ost_help_topic ost4 ON ost1.topic_id=ost4.topic_id 
            INNER JOIN ost_user ost5 ON ost1.user_id = ost5.id 
            INNER JOIN ost_organization ost6 ON ost6.id = ost5.org_id
            INNER JOIN rot_sucursal ost7 ON ost5.id_sucursal COLLATE utf8_unicode_ci = ost7.id_sucursal COLLATE utf8_unicode_ci 
            INNER JOIN ost_department ost8 ON ost3.dept_id = ost8.id
            INNER JOIN (
                SELECT @row_number:= CASE
                WHEN @object_id = object_id 
        			THEN @row_number + 1
                ELSE 1 END 
            	AS rn,  @object_id := ost9.object_id as object_id, ost9.id, ost10.thread_id, ost10.event_id, MAX(ost10.timestamp) AS timestamp
                FROM ost_thread_event ost10 INNER JOIN ost_thread ost9 ON ost9.id = ost10.thread_id AND ost10.event_id = 4
                GROUP BY ost9.object_id
                ORDER BY ost9.object_id, ost10.timestamp DESC)
            ost11 ON ost1.ticket_id = ost11.object_id AND ost11.rn = 1 ";
            if($fechaini != $fechafin){
                
                $fechaini = $fechaini.' 00:00:00';
                $fechafin = $fechafin.' 23:59:59';

                if($tipo == "All"){
                    $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                    OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."'
                    OR ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                }
                elseif($tipo == "Open"){
                    $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                   OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."') AND ost1.closed IS NULL" ;
                }
                elseif($tipo == "Created"){
                    $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."')";
                }
                elseif($tipo == "Updated"){
                    $sql .= "WHERE (ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."')";
                }
                elseif($tipo == "Closed"){
                    $sql .= "WHERE (ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                }
            }
            else{
                if($tipo == "All"){
                    $sql .="WHERE (ost1.created like '".$fechaini."%'
                    OR ost1.lastupdate like '".$fechaini."%'
                    OR ost1.closed like '".$fechaini."%')";
                }
                elseif($tipo == "Open"){
                    $sql .= "WHERE (ost1.created like '".$fechaini."%' OR ost1.lastupdate like '".$fechaini."%') AND ost1.closed IS NULL";
                }
                elseif($tipo == "Created"){
                    $sql .= "WHERE (ost1.created like '".$fechaini."%')";
                }
                elseif($tipo == "Updated"){
                    $sql .= "WHERE (ost1.lastupdate like '".$fechaini."%')";
                }
                elseif($tipo == "Closed"){
                    $sql .= "WHERE (ost1.closed like '".$fechaini."%')";
                }
            }
            if($cate != "TODAS"){
                $sql .= " AND ost4.topic_id = '".$cate."';";
            }
            return $this->getRows($sql);
        }

        //Obtiene la cantidad de tickets abiertos, cerrados y el total 
        public function categoria_cuantos_tickets($fechaini, $fechafin, $tipo, $cate){
            $sql = "SELECT SUM(uni.abiertos) AS abiertos, SUM(uni.cerrados) AS cerrados, (SUM(uni.abiertos) + SUM(uni.cerrados) ) AS cuantos, uni.topic FROM(
                SELECT count(*) AS abiertos, 0 AS cerrados, ost4.topic AS topic
                FROM ost_ticket__cdata ost2 
                INNER JOIN ost_ticket ost1 ON ost2.ticket_id=ost1.ticket_id 
                INNER JOIN ost_staff ost3 ON ost3.staff_id=ost1.staff_id 
                INNER JOIN ost_help_topic ost4 ON ost1.topic_id=ost4.topic_id 
                INNER JOIN ost_user ost5 ON ost1.user_id = ost5.id 
                INNER JOIN ost_organization ost6 ON ost6.id = ost5.org_id
                INNER JOIN rot_sucursal ost7 ON ost5.id_sucursal COLLATE utf8_unicode_ci = ost7.id_sucursal COLLATE utf8_unicode_ci 
                INNER JOIN ost_department ost8 ON ost3.dept_id = ost8.id
                INNER JOIN (
                    SELECT @row_number:= CASE
                    WHEN @object_id = object_id 
            			THEN @row_number + 1
                    ELSE 1 END 
                	AS rn,  @object_id := ost9.object_id as object_id, ost9.id, ost10.thread_id, ost10.event_id, MAX(ost10.timestamp) AS timestamp
                    FROM ost_thread_event ost10 INNER JOIN ost_thread ost9 ON ost9.id = ost10.thread_id AND ost10.event_id = 4
                    GROUP BY ost9.object_id
                    ORDER BY ost9.object_id, ost10.timestamp DESC)
                ost11 ON ost1.ticket_id = ost11.object_id AND ost11.rn = 1 ";
                if($fechaini != $fechafin){

                    $fechaini = $fechaini.' 00:00:00';
                    $fechafin = $fechafin.' 23:59:59';

                    if($tipo == "All"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                       OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."') AND ost1.closed IS NULL" ;
                    }
                    elseif($tipo == "Created"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Updated"){
                        $sql .= "WHERE (ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Closed"){
                        $sql .= "WHERE (ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                }
                else{
                    if($tipo == "All"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%'
                        OR ost1.lastupdate like '".$fechaini."%'
                        OR ost1.closed like '".$fechaini."%') ";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created like '".$fechaini."%' OR ost1.lastupdate like '".$fechaini."%') AND ost1.closed IS NULL";
                    }
                    elseif($tipo == "Created"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%') ";
                    }
                    elseif($tipo == "Updated"){
                        $sql .="WHERE (ost1.lastupdate like '".$fechaini."%') ";
                    }
                    elseif($tipo == "Closed"){
                        $sql .="WHERE (ost1.closed like '".$fechaini."%') ";
                    }
                }
                if($cate != "TODAS"){
                    $sql .= " AND ost4.topic_id = '".$cate."'";
                }
                $sql .= " AND ost1.closed IS NULL 
                UNION ALL 
                SELECT 0 AS abiertos, count(*) AS cerrados, ost4.topic AS topic
                FROM ost_ticket__cdata ost2 
                INNER JOIN ost_ticket ost1 ON ost2.ticket_id=ost1.ticket_id 
                INNER JOIN ost_staff ost3 ON ost3.staff_id=ost1.staff_id 
                INNER JOIN ost_help_topic ost4 ON ost1.topic_id=ost4.topic_id 
                INNER JOIN ost_user ost5 ON ost1.user_id = ost5.id 
                INNER JOIN ost_organization ost6 ON ost6.id = ost5.org_id
                INNER JOIN rot_sucursal ost7 ON ost5.id_sucursal COLLATE utf8_unicode_ci = ost7.id_sucursal COLLATE utf8_unicode_ci 
                INNER JOIN ost_department ost8 ON ost3.dept_id = ost8.id
                INNER JOIN (
                    SELECT @row_number:= CASE
                    WHEN @object_id = object_id 
            			THEN @row_number + 1
                    ELSE 1 END 
                	AS rn,  @object_id := ost9.object_id as object_id, ost9.id, ost10.thread_id, ost10.event_id, MAX(ost10.timestamp) AS timestamp
                    FROM ost_thread_event ost10 INNER JOIN ost_thread ost9 ON ost9.id = ost10.thread_id AND ost10.event_id = 4
                    GROUP BY ost9.object_id
                    ORDER BY ost9.object_id, ost10.timestamp DESC)
                ost11 ON ost1.ticket_id = ost11.object_id AND ost11.rn = 1 ";
                if($fechaini != $fechafin){

                    $fechaini = $fechaini.' 00:00:00';
                    $fechafin = $fechafin.' 23:59:59';

                    if($tipo == "All"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                       OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."') AND ost1.closed IS NULL" ;
                    }
                    elseif($tipo == "Created"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Updated"){
                        $sql .= "WHERE (ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Closed"){
                        $sql .= "WHERE (ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                }
                else{
                    if($tipo == "All"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%'
                        OR ost1.lastupdate like '".$fechaini."%'
                        OR ost1.closed like '".$fechaini."%') ";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created like '".$fechaini."%' OR ost1.lastupdate like '".$fechaini."%') AND ost1.closed IS NULL";
                    }
                    elseif($tipo == "Created"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%') ";
                    }
                    elseif($tipo == "Updated"){
                        $sql .="WHERE (ost1.lastupdate like '".$fechaini."%') ";
                    }
                    elseif($tipo == "Closed"){
                        $sql .="WHERE (ost1.closed like '".$fechaini."%') ";
                    }
                }
                if($cate != "TODAS"){
                    $sql .= " AND ost4.topic_id = '".$cate."'";
                }
                $sql .= " AND ost1.closed IS NOT NULL 
                 ) AS uni;";
                 
            return $this->getRow($sql);
        }

        //Obtiene la cantidad de tickets abiertos, cerrados, el total y el nombre de la categoría discriminado por categoría
        public function categoria_cuantos_categoria($fechaini, $fechafin, $tipo){
            $sql = "SELECT SUM(uni.abiertos) AS abiertos, SUM(uni.cerrados) AS cerrados, (SUM(uni.abiertos) + SUM(uni.cerrados) ) AS cuantos, uni.topic FROM(
                SELECT count(*) AS abiertos, 0 AS cerrados, ost4.topic AS topic
                FROM ost_ticket__cdata ost2 
                INNER JOIN ost_ticket ost1 ON ost2.ticket_id=ost1.ticket_id 
                INNER JOIN ost_staff ost3 ON ost3.staff_id=ost1.staff_id 
                INNER JOIN ost_help_topic ost4 ON ost1.topic_id=ost4.topic_id 
                INNER JOIN ost_user ost5 ON ost1.user_id = ost5.id 
                INNER JOIN ost_organization ost6 ON ost6.id = ost5.org_id
                INNER JOIN rot_sucursal ost7 ON ost5.id_sucursal COLLATE utf8_unicode_ci = ost7.id_sucursal COLLATE utf8_unicode_ci 
                INNER JOIN ost_department ost8 ON ost3.dept_id = ost8.id
                INNER JOIN (
                    SELECT @row_number:= CASE
                    WHEN @object_id = object_id 
            			THEN @row_number + 1
                    ELSE 1 END 
                	AS rn,  @object_id := ost9.object_id as object_id, ost9.id, ost10.thread_id, ost10.event_id, MAX(ost10.timestamp) AS timestamp
                    FROM ost_thread_event ost10 INNER JOIN ost_thread ost9 ON ost9.id = ost10.thread_id AND ost10.event_id = 4
                    GROUP BY ost9.object_id
                    ORDER BY ost9.object_id, ost10.timestamp DESC)
                ost11 ON ost1.ticket_id = ost11.object_id AND ost11.rn = 1 ";
                if($fechaini != $fechafin){

                    $fechaini = $fechaini.' 00:00:00';
                    $fechafin = $fechafin.' 23:59:59';

                    if($tipo == "All"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                       OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."') AND ost1.closed IS NULL" ;
                    }
                    elseif($tipo == "Created"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Updated"){
                        $sql .= "WHERE (ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Closed"){
                        $sql .= "WHERE (ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                }
                else{
                    if($tipo == "All"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%'
                        OR ost1.lastupdate like '".$fechaini."%'
                        OR ost1.closed like '".$fechaini."%')";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created like '".$fechaini."%' OR ost1.lastupdate like '".$fechaini."%') AND ost1.closed IS NULL";
                    }
                    elseif($tipo == "Created"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%')";
                    }
                    elseif($tipo == "Updated"){
                        $sql .="WHERE (ost1.lastupdate like '".$fechaini."%')";
                    }
                    elseif($tipo == "Closed"){
                        $sql .="WHERE (ost1.closed like '".$fechaini."%')";
                    }
                }
                $sql .= " AND ost1.closed IS NULL
                GROUP BY ost4.topic
                UNION ALL 
                SELECT 0 AS abiertos, count(*) AS cerrados, ost4.topic AS topic
                FROM ost_ticket__cdata ost2 
                INNER JOIN ost_ticket ost1 ON ost2.ticket_id=ost1.ticket_id 
                INNER JOIN ost_staff ost3 ON ost3.staff_id=ost1.staff_id 
                INNER JOIN ost_help_topic ost4 ON ost1.topic_id=ost4.topic_id 
                INNER JOIN ost_user ost5 ON ost1.user_id = ost5.id 
                INNER JOIN ost_organization ost6 ON ost6.id = ost5.org_id
                INNER JOIN rot_sucursal ost7 ON ost5.id_sucursal COLLATE utf8_unicode_ci = ost7.id_sucursal COLLATE utf8_unicode_ci 
                INNER JOIN ost_department ost8 ON ost3.dept_id = ost8.id
                INNER JOIN (
                   SELECT @row_number:= CASE
                    WHEN @object_id = object_id 
            			THEN @row_number + 1
                    ELSE 1 END 
                	AS rn,  @object_id := ost9.object_id as object_id, ost9.id, ost10.thread_id, ost10.event_id, MAX(ost10.timestamp) AS timestamp
                    FROM ost_thread_event ost10 INNER JOIN ost_thread ost9 ON ost9.id = ost10.thread_id AND ost10.event_id = 4
                    GROUP BY ost9.object_id
                    ORDER BY ost9.object_id, ost10.timestamp DESC)
                ost11 ON ost1.ticket_id = ost11.object_id AND ost11.rn = 1 ";
                if($fechaini != $fechafin){

                    $fechaini = $fechaini.' 00:00:00';
                    $fechafin = $fechafin.' 23:59:59';

                    if($tipo == "All"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                       OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."') AND ost1.closed IS NULL" ;
                    }
                    elseif($tipo == "Created"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Updated"){
                        $sql .= "WHERE (ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Closed"){
                        $sql .= "WHERE (ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                }
                else{
                    if($tipo == "All"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%'
                        OR ost1.lastupdate like '".$fechaini."%'
                        OR ost1.closed like '".$fechaini."%')";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created like '".$fechaini."%' OR ost1.lastupdate like '".$fechaini."%') AND ost1.closed IS NULL";
                    }
                    elseif($tipo == "Created"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%')";
                    }
                    elseif($tipo == "Updated"){
                        $sql .="WHERE (ost1.lastupdate like '".$fechaini."%')";
                    }
                    elseif($tipo == "Closed"){
                        $sql .="WHERE (ost1.closed like '".$fechaini."%')";
                    }
                }
                $sql .= " AND ost1.closed IS NOT NULL 
                GROUP BY ost4.topic) AS uni
            GROUP BY uni.topic;";
            // echo $sql;
            return $this->getRows($sql);
        }
    }
    // Objetos para usar en categoria.php
    $categoria = new categoria();
    $categoria1 = new categoria();
    $categoria2 = new categoria();
    $categoria3 = new categoria();

// --------------------- DASHBOARD CATEGORIA --------------------- //

// --------------------- DASHBOARD SUCURSAL ---------------------- //
    class sucursal extends Database implements iSucursal{

        // Obtiene la información de todos los tickets
        public function sucursal_all_tickets($fechaini, $fechafin, $tipo, $cate, $suc){
            $sql = "SELECT ost1.number, ost4.topic, ost2.subject, ost5.name, ost5.area, ost5.depto,
            ost6.name AS regional, 
            ost7.nombre AS sucursal,
            DATE_FORMAT(ost1.created, '%d-%m-%Y') AS created, 
            DATE_FORMAT(ost1.lastupdate, '%d-%m-%Y') AS lastupdate, 
            DATE_FORMAT(ost1.closed, '%d-%m-%Y') AS closed, ost3.username, ost8.name AS departamento, 
            TIMEDIFF(ost11.timestamp, ost1.created) AS tiempoRespuesta,
            TIMEDIFF(ost1.lastupdate, ost1.created) AS tiempo
            FROM ost_ticket__cdata ost2 
            INNER JOIN ost_ticket ost1 ON ost2.ticket_id=ost1.ticket_id 
            INNER JOIN ost_staff ost3 ON ost3.staff_id=ost1.staff_id 
            INNER JOIN ost_help_topic ost4 ON ost1.topic_id=ost4.topic_id 
            INNER JOIN ost_user ost5 ON ost1.user_id = ost5.id 
            INNER JOIN ost_organization ost6 ON ost6.id = ost5.org_id
            INNER JOIN rot_sucursal ost7 ON ost5.id_sucursal COLLATE utf8_unicode_ci = ost7.id_sucursal COLLATE utf8_unicode_ci 
            INNER JOIN ost_department ost8 ON ost3.dept_id = ost8.id
            INNER JOIN (
                SELECT @row_number:= CASE
                WHEN @object_id = object_id 
        			THEN @row_number + 1
                ELSE 1 END 
            	AS rn,  @object_id := ost9.object_id as object_id, ost9.id, ost10.thread_id, ost10.event_id, MAX(ost10.timestamp) AS timestamp
                FROM ost_thread_event ost10 INNER JOIN ost_thread ost9 ON ost9.id = ost10.thread_id AND ost10.event_id = 4
                GROUP BY ost9.object_id
                ORDER BY ost9.object_id, ost10.timestamp DESC)
                ost11 ON ost1.ticket_id = ost11.object_id AND ost11.rn = 1 ";
            if($fechaini != $fechafin){
                
                $fechaini = $fechaini.' 00:00:00';
                $fechafin = $fechafin.' 23:59:59';

                if($tipo == "All"){
                    $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                    OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."'
                    OR ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                }
                elseif($tipo == "Open"){
                    $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                   OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."') AND ost1.closed IS NULL" ;
                }
                elseif($tipo == "Created"){
                    $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."')";
                }
                elseif($tipo == "Updated"){
                    $sql .= "WHERE (ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."')";
                }
                elseif($tipo == "Closed"){
                    $sql .= "WHERE (ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                }
            }
            else{
                if($tipo == "All"){
                    $sql .="WHERE (ost1.created like '".$fechaini."%'
                    OR ost1.lastupdate like '".$fechaini."%'
                    OR ost1.closed like '".$fechaini."%')";
                }
                elseif($tipo == "Open"){
                    $sql .= "WHERE (ost1.created like '".$fechaini."%' OR ost1.lastupdate like '".$fechaini."%') AND ost1.closed IS NULL";
                }
                elseif($tipo == "Created"){
                    $sql .= "WHERE (ost1.created like '".$fechaini."%')";
                }
                elseif($tipo == "Updated"){
                    $sql .= "WHERE (ost1.lastupdate like '".$fechaini."%')";
                }
                elseif($tipo == "Closed"){
                    $sql .= "WHERE (ost1.closed like '".$fechaini."%')";
                }
            }
            $sql .= " AND ost7.nombre = '".$suc."'";
            if($cate != "TODAS"){
                $sql .= " AND ost4.topic_id = '".$cate."'";
            }
            $sql .= ";";
            return $this->getRows($sql);
        }

        // Obtiene la cantidad de tickets abiertos y cerrados
        public function sucursal_cuantos_tickets($fechaini, $fechafin, $tipo, $cate, $suc){
            $sql = "SELECT SUM(uni.abiertos) AS abiertos, SUM(uni.cerrados) AS cerrados, (SUM(uni.abiertos) + SUM(uni.cerrados) ) AS cuantos FROM(
                SELECT count(*) AS abiertos, 0 AS cerrados
                FROM ost_ticket__cdata ost2 
                INNER JOIN ost_ticket ost1 ON ost2.ticket_id=ost1.ticket_id 
                INNER JOIN ost_staff ost3 ON ost3.staff_id=ost1.staff_id 
                INNER JOIN ost_help_topic ost4 ON ost1.topic_id=ost4.topic_id 
                INNER JOIN ost_user ost5 ON ost1.user_id = ost5.id 
                INNER JOIN ost_organization ost6 ON ost6.id = ost5.org_id
                INNER JOIN rot_sucursal ost7 ON ost5.id_sucursal COLLATE utf8_unicode_ci = ost7.id_sucursal COLLATE utf8_unicode_ci 
                INNER JOIN ost_department ost8 ON ost3.dept_id = ost8.id
                INNER JOIN (
                    SELECT @row_number:= CASE
                    WHEN @object_id = object_id 
            			THEN @row_number + 1
                    ELSE 1 END 
                	AS rn,  @object_id := ost9.object_id as object_id, ost9.id, ost10.thread_id, ost10.event_id, MAX(ost10.timestamp) AS timestamp
                    FROM ost_thread_event ost10 INNER JOIN ost_thread ost9 ON ost9.id = ost10.thread_id AND ost10.event_id = 4
                    GROUP BY ost9.object_id
                    ORDER BY ost9.object_id, ost10.timestamp DESC)
                    ost11 ON ost1.ticket_id = ost11.object_id AND ost11.rn = 1 ";
                if($fechaini != $fechafin){

                    $fechaini = $fechaini.' 00:00:00';
                    $fechafin = $fechafin.' 23:59:59';

                    if($tipo == "All"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                       OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."') AND ost1.closed IS NULL" ;
                    }
                    elseif($tipo == "Created"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Updated"){
                        $sql .= "WHERE (ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Closed"){
                        $sql .= "WHERE (ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                }
                else{
                    if($tipo == "All"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%'
                        OR ost1.lastupdate like '".$fechaini."%'
                        OR ost1.closed like '".$fechaini."%') ";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created like '".$fechaini."%' OR ost1.lastupdate like '".$fechaini."%') AND ost1.closed IS NULL";
                    }
                    elseif($tipo == "Created"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%') ";
                    }
                    elseif($tipo == "Updated"){
                        $sql .="WHERE (ost1.lastupdate like '".$fechaini."%') ";
                    }
                    elseif($tipo == "Closed"){
                        $sql .="WHERE (ost1.closed like '".$fechaini."%') ";
                    }
                }
                $sql .= " AND ost7.nombre = '".$suc."'";
                if($cate != "TODAS"){
                    $sql .= " AND ost4.topic_id = '".$cate."'";
                }
                $sql .= " AND ost1.closed IS NULL 
                UNION ALL 
                SELECT 0 AS abiertos, count(*) AS cerrados
                FROM ost_ticket__cdata ost2 
                INNER JOIN ost_ticket ost1 ON ost2.ticket_id=ost1.ticket_id 
                INNER JOIN ost_staff ost3 ON ost3.staff_id=ost1.staff_id 
                INNER JOIN ost_help_topic ost4 ON ost1.topic_id=ost4.topic_id 
                INNER JOIN ost_user ost5 ON ost1.user_id = ost5.id 
                INNER JOIN ost_organization ost6 ON ost6.id = ost5.org_id
                INNER JOIN rot_sucursal ost7 ON ost5.id_sucursal COLLATE utf8_unicode_ci = ost7.id_sucursal COLLATE utf8_unicode_ci 
                INNER JOIN ost_department ost8 ON ost3.dept_id = ost8.id
                INNER JOIN (
                    SELECT @row_number:= CASE
                    WHEN @object_id = object_id 
            			THEN @row_number + 1
                    ELSE 1 END 
                	AS rn,  @object_id := ost9.object_id as object_id, ost9.id, ost10.thread_id, ost10.event_id, MAX(ost10.timestamp) AS timestamp
                    FROM ost_thread_event ost10 INNER JOIN ost_thread ost9 ON ost9.id = ost10.thread_id AND ost10.event_id = 4
                    GROUP BY ost9.object_id
                    ORDER BY ost9.object_id, ost10.timestamp DESC)
                    ost11 ON ost1.ticket_id = ost11.object_id AND ost11.rn = 1 ";
                if($fechaini != $fechafin){

                    $fechaini = $fechaini.' 00:00:00';
                    $fechafin = $fechafin.' 23:59:59';

                    if($tipo == "All"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                       OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."') AND ost1.closed IS NULL" ;
                    }
                    elseif($tipo == "Created"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Updated"){
                        $sql .= "WHERE (ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Closed"){
                        $sql .= "WHERE (ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                }
                else{
                    if($tipo == "All"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%'
                        OR ost1.lastupdate like '".$fechaini."%'
                        OR ost1.closed like '".$fechaini."%') ";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created like '".$fechaini."%' OR ost1.lastupdate like '".$fechaini."%') AND ost1.closed IS NULL";
                    }
                    elseif($tipo == "Created"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%') ";
                    }
                    elseif($tipo == "Updated"){
                        $sql .="WHERE (ost1.lastupdate like '".$fechaini."%') ";
                    }
                    elseif($tipo == "Closed"){
                        $sql .="WHERE (ost1.closed like '".$fechaini."%') ";
                    }
                }
                $sql .= " AND ost7.nombre = '".$suc."'";
                if($cate != "TODAS"){
                    $sql .= " AND ost4.topic_id = '".$cate."'";
                }
                $sql .= " AND ost1.closed IS NOT NULL 
                 ) AS uni;";
                 
            return $this->getRow($sql);
        }

        // obtiene la información de las sucursales
        public function sucursal_busca_sucursal($sucursal){
            $sql = "SELECT id_sucursal, nombre 
            FROM rot_sucursal 
            WHERE (id_sucursal LIKE '%".$sucursal."%' OR nombre LIKE '%".$sucursal."%')";
            return $this->getRows($sql);
        }
    }

    // Objetos para usar en sucursal.php
    $sucu = new sucursal();
    $sucu1 = new sucursal();
    $sucu2 = new sucursal();
// --------------------- DASHBOARD SUCURSAL ---------------------- //

// --------------------- DASHBOARD REGIONAL ---------------------- //
    class regional extends Database implements iRegional{

        // obtiene la información de los regionales
        public function regional_regional(){
            $sql = "SELECT * FROM ost_organization ORDER BY name";
            return $this->getRows($sql);
        }

        // Obtiene los datos de los regionales
        public function regional_busca_regional($regional){
            $sql = "SELECT name 
            FROM ost_organization
            WHERE (name LIKE '%".$regional."%')";
            return $this->getRows($sql);
        }

        // Obtiene la informacion de todos los tickets
        public function regional_all_tickets($fechaini, $fechafin, $tipo, $cate, $reg){
             $sql = "SELECT ost1.number, ost4.topic, ost2.subject, ost5.name, ost5.area, ost5.depto,
            ost6.name AS regional, 
            ost7.nombre AS sucursal,
            DATE_FORMAT(ost1.created, '%d-%m-%Y') AS created, 
            DATE_FORMAT(ost1.lastupdate, '%d-%m-%Y') AS lastupdate, 
            DATE_FORMAT(ost1.closed, '%d-%m-%Y') AS closed, ost3.username, ost8.name AS departamento,  
            TIMEDIFF(ost11.timestamp, ost1.created) AS tiempoRespuesta,
            TIMEDIFF(ost1.lastupdate, ost1.created) AS tiempo
            FROM ost_ticket__cdata ost2 
            INNER JOIN ost_ticket ost1 ON ost2.ticket_id=ost1.ticket_id 
            INNER JOIN ost_staff ost3 ON ost3.staff_id=ost1.staff_id 
            INNER JOIN ost_help_topic ost4 ON ost1.topic_id=ost4.topic_id 
            INNER JOIN ost_user ost5 ON ost1.user_id = ost5.id 
            INNER JOIN ost_organization ost6 ON ost6.id = ost5.org_id
            INNER JOIN rot_sucursal ost7 ON ost5.id_sucursal COLLATE utf8_unicode_ci = ost7.id_sucursal COLLATE utf8_unicode_ci 
            INNER JOIN ost_department ost8 ON ost3.dept_id = ost8.id
            INNER JOIN (
                SELECT @row_number:= CASE
                WHEN @object_id = object_id 
        			THEN @row_number + 1
                ELSE 1 END 
            	AS rn,  @object_id := ost9.object_id as object_id, ost9.id, ost10.thread_id, ost10.event_id, MAX(ost10.timestamp) AS timestamp
                FROM ost_thread_event ost10 INNER JOIN ost_thread ost9 ON ost9.id = ost10.thread_id AND ost10.event_id = 4
                GROUP BY ost9.object_id
                ORDER BY ost9.object_id, ost10.timestamp DESC)
            ost11 ON ost1.ticket_id = ost11.object_id AND ost11.rn = 1 ";
            if($fechaini != $fechafin){
                
                $fechaini = $fechaini.' 00:00:00';
                $fechafin = $fechafin.' 23:59:59';

                if($tipo == "All"){
                    $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                    OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."'
                    OR ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                }
                elseif($tipo == "Open"){
                    $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                   OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."') AND ost1.closed IS NULL" ;
                }
                elseif($tipo == "Created"){
                    $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."')";
                }
                elseif($tipo == "Updated"){
                    $sql .= "WHERE (ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."')";
                }
                elseif($tipo == "Closed"){
                    $sql .= "WHERE (ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                }
            }
            else{
                if($tipo == "All"){
                    $sql .="WHERE (ost1.created like '".$fechaini."%'
                    OR ost1.lastupdate like '".$fechaini."%'
                    OR ost1.closed like '".$fechaini."%')";
                }
                elseif($tipo == "Open"){
                    $sql .= "WHERE (ost1.created like '".$fechaini."%' OR ost1.lastupdate like '".$fechaini."%') AND ost1.closed IS NULL";
                }
                elseif($tipo == "Created"){
                    $sql .= "WHERE (ost1.created like '".$fechaini."%')";
                }
                elseif($tipo == "Updated"){
                    $sql .= "WHERE (ost1.lastupdate like '".$fechaini."%')";
                }
                elseif($tipo == "Closed"){
                    $sql .= "WHERE (ost1.closed like '".$fechaini."%')";
                }
            }
            if($reg != "TODOS"){
                $sql .= " AND ost6.name = '".$reg."'";
            }
            if($cate != "TODAS"){
                $sql .= " AND ost4.topic_id = '".$cate."'";
            }
            $sql .= ";";
            return $this->getRows($sql);
        }

        // Obtiene la información de cuantos ticket abierto y cerrados existen
        public function regional_cuantos_tickets($fechaini, $fechafin, $tipo, $cate, $reg){
            $sql = "SELECT SUM(uni.abiertos) AS abiertos, SUM(uni.cerrados) AS cerrados, (SUM(uni.abiertos) + SUM(uni.cerrados) ) AS cuantos FROM(
                SELECT count(*) AS abiertos, 0 AS cerrados
                FROM ost_ticket__cdata ost2 
                INNER JOIN ost_ticket ost1 ON ost2.ticket_id=ost1.ticket_id 
                INNER JOIN ost_staff ost3 ON ost3.staff_id=ost1.staff_id 
                INNER JOIN ost_help_topic ost4 ON ost1.topic_id=ost4.topic_id 
                INNER JOIN ost_user ost5 ON ost1.user_id = ost5.id 
                INNER JOIN ost_organization ost6 ON ost6.id = ost5.org_id
                INNER JOIN rot_sucursal ost7 ON ost5.id_sucursal COLLATE utf8_unicode_ci = ost7.id_sucursal COLLATE utf8_unicode_ci 
                INNER JOIN ost_department ost8 ON ost3.dept_id = ost8.id
                INNER JOIN (
                    SELECT @row_number:= CASE
                    WHEN @object_id = object_id 
            			THEN @row_number + 1
                    ELSE 1 END 
                	AS rn,  @object_id := ost9.object_id as object_id, ost9.id, ost10.thread_id, ost10.event_id, MAX(ost10.timestamp) AS timestamp
                    FROM ost_thread_event ost10 INNER JOIN ost_thread ost9 ON ost9.id = ost10.thread_id AND ost10.event_id = 4
                    GROUP BY ost9.object_id
                    ORDER BY ost9.object_id, ost10.timestamp DESC)
                ost11 ON ost1.ticket_id = ost11.object_id AND ost11.rn = 1 ";
                if($fechaini != $fechafin){

                    $fechaini = $fechaini.' 00:00:00';
                    $fechafin = $fechafin.' 23:59:59';

                    if($tipo == "All"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                       OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."') AND ost1.closed IS NULL" ;
                    }
                    elseif($tipo == "Created"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Updated"){
                        $sql .= "WHERE (ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Closed"){
                        $sql .= "WHERE (ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                }
                else{
                    if($tipo == "All"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%'
                        OR ost1.lastupdate like '".$fechaini."%'
                        OR ost1.closed like '".$fechaini."%') ";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created like '".$fechaini."%' OR ost1.lastupdate like '".$fechaini."%') AND ost1.closed IS NULL";
                    }
                    elseif($tipo == "Created"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%') ";
                    }
                    elseif($tipo == "Updated"){
                        $sql .="WHERE (ost1.lastupdate like '".$fechaini."%') ";
                    }
                    elseif($tipo == "Closed"){
                        $sql .="WHERE (ost1.closed like '".$fechaini."%') ";
                    }
                }
                if($reg != "TODOS"){
                    $sql .= " AND ost6.name = '".$reg."'";
                }
                if($cate != "TODAS"){
                    $sql .= " AND ost4.topic_id = '".$cate."'";
                }
                $sql .= " AND ost1.closed IS NULL 
                UNION ALL 
                SELECT 0 AS abiertos, count(*) AS cerrados
                FROM ost_ticket__cdata ost2 
                INNER JOIN ost_ticket ost1 ON ost2.ticket_id=ost1.ticket_id 
                INNER JOIN ost_staff ost3 ON ost3.staff_id=ost1.staff_id 
                INNER JOIN ost_help_topic ost4 ON ost1.topic_id=ost4.topic_id 
                INNER JOIN ost_user ost5 ON ost1.user_id = ost5.id 
                INNER JOIN ost_organization ost6 ON ost6.id = ost5.org_id
                INNER JOIN rot_sucursal ost7 ON ost5.id_sucursal COLLATE utf8_unicode_ci = ost7.id_sucursal COLLATE utf8_unicode_ci 
                INNER JOIN ost_department ost8 ON ost3.dept_id = ost8.id
                INNER JOIN (
                    SELECT @row_number:= CASE
                    WHEN @object_id = object_id 
            			THEN @row_number + 1
                    ELSE 1 END 
                	AS rn,  @object_id := ost9.object_id as object_id, ost9.id, ost10.thread_id, ost10.event_id, MAX(ost10.timestamp) AS timestamp
                    FROM ost_thread_event ost10 INNER JOIN ost_thread ost9 ON ost9.id = ost10.thread_id AND ost10.event_id = 4
                    GROUP BY ost9.object_id
                    ORDER BY ost9.object_id, ost10.timestamp DESC)
                ost11 ON ost1.ticket_id = ost11.object_id AND ost11.rn = 1 ";
                if($fechaini != $fechafin){

                    $fechaini = $fechaini.' 00:00:00';
                    $fechafin = $fechafin.' 23:59:59';

                    if($tipo == "All"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                       OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."') AND ost1.closed IS NULL" ;
                    }
                    elseif($tipo == "Created"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Updated"){
                        $sql .= "WHERE (ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Closed"){
                        $sql .= "WHERE (ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                }
                else{
                    if($tipo == "All"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%'
                        OR ost1.lastupdate like '".$fechaini."%'
                        OR ost1.closed like '".$fechaini."%') ";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created like '".$fechaini."%' OR ost1.lastupdate like '".$fechaini."%') AND ost1.closed IS NULL";
                    }
                    elseif($tipo == "Created"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%') ";
                    }
                    elseif($tipo == "Updated"){
                        $sql .="WHERE (ost1.lastupdate like '".$fechaini."%') ";
                    }
                    elseif($tipo == "Closed"){
                        $sql .="WHERE (ost1.closed like '".$fechaini."%') ";
                    }
                }
                if($reg != "TODOS"){
                    $sql .= " AND ost6.name = '".$reg."'";
                }
                if($cate != "TODAS"){
                    $sql .= " AND ost4.topic_id = '".$cate."'";
                }
                $sql .= " AND ost1.closed IS NOT NULL 
                 ) AS uni;";
            return $this->getRow($sql);
        }

        // Obtiene la información de cuantos ticket abiertos y cerrados existen discriminados por regional
        public function regional_cuantos_categoria($fechaini, $fechafin, $tipo){
            $sql = "SELECT SUM(uni.abiertos) AS abiertos, SUM(uni.cerrados) AS cerrados, (SUM(uni.abiertos) + SUM(uni.cerrados) ) AS cuantos, uni.regional FROM(
                SELECT count(*) AS abiertos, 0 AS cerrados, ost6.name AS regional
                FROM ost_ticket__cdata ost2 
                INNER JOIN ost_ticket ost1 ON ost2.ticket_id=ost1.ticket_id 
                INNER JOIN ost_staff ost3 ON ost3.staff_id=ost1.staff_id 
                INNER JOIN ost_help_topic ost4 ON ost1.topic_id=ost4.topic_id 
                INNER JOIN ost_user ost5 ON ost1.user_id = ost5.id 
                INNER JOIN ost_organization ost6 ON ost6.id = ost5.org_id
                INNER JOIN rot_sucursal ost7 ON ost5.id_sucursal COLLATE utf8_unicode_ci = ost7.id_sucursal COLLATE utf8_unicode_ci 
                INNER JOIN ost_department ost8 ON ost3.dept_id = ost8.id
                INNER JOIN (
                    SELECT @row_number:= CASE
                    WHEN @object_id = object_id 
            			THEN @row_number + 1
                    ELSE 1 END 
                	AS rn,  @object_id := ost9.object_id as object_id, ost9.id, ost10.thread_id, ost10.event_id, MAX(ost10.timestamp) AS timestamp
                    FROM ost_thread_event ost10 INNER JOIN ost_thread ost9 ON ost9.id = ost10.thread_id AND ost10.event_id = 4
                    GROUP BY ost9.object_id
                    ORDER BY ost9.object_id, ost10.timestamp DESC)
                ost11 ON ost1.ticket_id = ost11.object_id AND ost11.rn = 1 ";
                if($fechaini != $fechafin){

                    $fechaini = $fechaini.' 00:00:00';
                    $fechafin = $fechafin.' 23:59:59';

                    if($tipo == "All"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                       OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."') AND ost1.closed IS NULL" ;
                    }
                    elseif($tipo == "Created"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Updated"){
                        $sql .= "WHERE (ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Closed"){
                        $sql .= "WHERE (ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                }
                else{
                    if($tipo == "All"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%'
                        OR ost1.lastupdate like '".$fechaini."%'
                        OR ost1.closed like '".$fechaini."%')";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created like '".$fechaini."%' OR ost1.lastupdate like '".$fechaini."%') AND ost1.closed IS NULL";
                    }
                    elseif($tipo == "Created"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%')";
                    }
                    elseif($tipo == "Updated"){
                        $sql .="WHERE (ost1.lastupdate like '".$fechaini."%')";
                    }
                    elseif($tipo == "Closed"){
                        $sql .="WHERE (ost1.closed like '".$fechaini."%')";
                    }
                }
                $sql .= " AND ost1.closed IS NULL
                GROUP BY ost6.name
                UNION ALL 
                SELECT 0 AS abiertos, count(*) AS cerrados, ost6.name AS regional
                FROM ost_ticket__cdata ost2 
                INNER JOIN ost_ticket ost1 ON ost2.ticket_id=ost1.ticket_id 
                INNER JOIN ost_staff ost3 ON ost3.staff_id=ost1.staff_id 
                INNER JOIN ost_help_topic ost4 ON ost1.topic_id=ost4.topic_id 
                INNER JOIN ost_user ost5 ON ost1.user_id = ost5.id 
                INNER JOIN ost_organization ost6 ON ost6.id = ost5.org_id
                INNER JOIN rot_sucursal ost7 ON ost5.id_sucursal COLLATE utf8_unicode_ci = ost7.id_sucursal COLLATE utf8_unicode_ci 
                INNER JOIN ost_department ost8 ON ost3.dept_id = ost8.id
                INNER JOIN (
                    SELECT @row_number:= CASE
                    WHEN @object_id = object_id 
            			THEN @row_number + 1
                    ELSE 1 END 
                	AS rn,  @object_id := ost9.object_id as object_id, ost9.id, ost10.thread_id, ost10.event_id, MAX(ost10.timestamp) AS timestamp
                    FROM ost_thread_event ost10 INNER JOIN ost_thread ost9 ON ost9.id = ost10.thread_id AND ost10.event_id = 4
                    GROUP BY ost9.object_id
                    ORDER BY ost9.object_id, ost10.timestamp DESC)
                ost11 ON ost1.ticket_id = ost11.object_id AND ost11.rn = 1 ";
                if($fechaini != $fechafin){

                    $fechaini = $fechaini.' 00:00:00';
                    $fechafin = $fechafin.' 23:59:59';

                    if($tipo == "All"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                       OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."') AND ost1.closed IS NULL" ;
                    }
                    elseif($tipo == "Created"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Updated"){
                        $sql .= "WHERE (ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Closed"){
                        $sql .= "WHERE (ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                }
                else{
                    if($tipo == "All"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%'
                        OR ost1.lastupdate like '".$fechaini."%'
                        OR ost1.closed like '".$fechaini."%')";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created like '".$fechaini."%' OR ost1.lastupdate like '".$fechaini."%') AND ost1.closed IS NULL";
                    }
                    elseif($tipo == "Created"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%')";
                    }
                    elseif($tipo == "Updated"){
                        $sql .="WHERE (ost1.lastupdate like '".$fechaini."%')";
                    }
                    elseif($tipo == "Closed"){
                        $sql .="WHERE (ost1.closed like '".$fechaini."%')";
                    }
                }
                $sql .= " AND ost1.closed IS NOT NULL 
                GROUP BY ost6.name) AS uni
            GROUP BY uni.regional;";
            return $this->getRows($sql);
        }
    }

    // Objetos para usar en regional.php
    $regi = new regional();
    $regi1 = new regional();
    $regi2 = new regional();
    $regi3 = new regional();

// --------------------- DASHBOARD REGIONAL ---------------------- //

?>